#!/usr/bin/perl -w

use CGI;

my $ildroot="/home/olaf/ild/";

$query = new CGI;



if($query->param("mode")) {
if($query->param("mode") eq "query") {


print $query->header;
print $query->start_html("ILD - Interaktive Lerndatenbank by O. Schmidt"),
  $query->h1("ILD - Interaktive Lerndatenbank"),$query->p;
print $query->startform;
print $query->hidden("mode","query");

my $user;
my $lektion;

#unless(checkpw($query->param("user"),$query->param("password"))) {
if(!($user=$query->param("user"))) {
  print $query->p("Hallo und Willkommen bei ILD! Bitte melde Dich zunchst an:"),
  "Username: ".$query->textfield("user"),
  #  "Passwort: ".$query->password_field("password").
  $query->p,
  $query->submit("Anmelden");
} else { # User logged in
  open USER,"$ildroot/users/$user"
    || print "Kann user $user Datenbank nicht oeffnen.";
  while(<USER>) {
    $userdata{$1}=$2 if(/^(.*?) (.*)/);
  }
  close USER;
  $userdata{'punkte'}=0 unless ($userdata{'punkte'});

  if($query->param("button") eq "Lektion whlen") { # Lektion waehlen
    $query->delete('button');
    print $query->h2("Lektion auswhlen");
    foreach (glob($ildroot."lektionen/*")) {
      $_=~s/($ildroot)lektionen\///;
      # $query->param('lektion',$_);
      # print "<a href=".$query->self_url.">$_</a><br>\n";
      print $query->submit("lektion",$_).$query->br;
    }
  } else { # no button
    if($lektion=$query->param("lektion")) {
      # $userdata{"lektion"}=$query->param("lektion");
      $userdata{"lektion"}=$lektion;
      $userdata{"fragenr"}=1;
      $query->delete("lektion");
    }
    if($lektion=$userdata{"lektion"})
      {
	open IN,"$ildroot/lektionen/$lektion";  # Fragen einlesen
	$fragenr=1;
	$fragestr=<IN>;
	foreach $_ (<IN>) {
	  chomp $_;
	  ($fr,$ant)=split(/:/,$_);
	  $frage{$fragenr}=$fr;
	  $antwort{$fragenr++}=$ant;
	}
	close IN;
	$fragenr=$userdata{"fragenr"};
	print $query->p("Lektion <b>$lektion</b>");
	if($fragenr &&              # Antwort bearbeiten
	   $query->param("antwort") &&
	   $frage{$fragenr}) {
	  print "Letzte Frage: <b>",$frage{$fragenr},
	  "</b><br>Letzte Antwort: <b>",$query->param("antwort"),
	  "</b><br>Richtige Antwort: <b>",$antwort{$fragenr},
	  "</b>\n";
	  if ($query->param("antwort") eq $antwort{$fragenr}) {
	    $userdata{'punkte'}+=2; 
	    print "<font color=red>Richtig!</font>\n";
	  } else { 
	    $userdata{'punkte'}--; 
	    print "<font color=blue>Falsch!</font>\n";
	  }
	  $userdata{"fragenr"}=++$fragenr;
	}
	$query->delete("antwort");

	unless ($fragenr > scalar keys %frage) {
	  print $query->h2($fragestr);
	  print "Frage Nr. $fragenr<br>Frage: ".$frage{$fragenr};
	  print $query->h2("Antwort:");
	  print $query->textfield("antwort");
	  print $query->submit("Abschicken");
	} else {
	  $userdata{"fragenr"}=0;
	  $userdata{"lektion"}="";
	}
      }
  }
}

# Footer
print $query->hr,
  "Benutzer: <b>$user</b> Punkte: <b>$userdata{'punkte'}</b><br>\n";
print $query->hidden('user',$user);

print $query->submit("button","Lektion whlen").$query->hr;

print $query->endform;
print $query->p(`date`),$query->dump;
print $query->end_html;

open USER,">$ildroot/users/$user"
  || print "Kann user $user Datenbank nicht schreiben.";
foreach $_ (keys %userdata) {
  print USER "$_ $userdata{$_}\n";
}
close USER;

} elsif($query->param("mode") eq "hit") { # hit list

print $query->header(-Refresh=>'10;URL='.$query->self_url);
print $query->start_html("ILD - Interaktive Lerndatenbank by O. Schmidt"),
  $query->h1("ILD - Hitliste"),$query->p;

foreach $user (glob($ildroot."users/*")) {
  $userdata=();
  open USER,$user;
  while(<USER>) {
    $userdata{$1}=$2 if(/^(.*?) (.*)/);
  }
  close USER;
  $user=~s/($ildroot)users\///;
  $hitliste{$user}=$userdata{"punkte"};
}
print "<table>";
foreach (reverse sort {$hitliste{$a} <=> $hitliste{$b}} keys %hitliste) {
print "<tr><td>$_</td><td>$hitliste{$_}</td></tr>\n";
}
print "</table>".$query->dump.$query->end_html;
}
} else {  # index.html       for framework
print $query->header;
$query->delete_all;
print <<EOM;
<html>
  <head>
    <title>ILD - Interaktive Lerndatenbank, (c) O.Schmidt</title>
  </head>
  <frameset cols="70%,30%">
    <NOFRAMES>
      Bitte benutzen Sie einen Browser, der Frames versteht.
      Wenn Sie keine Frames haben, dann dr&uuml;cken Sie
      <a href="main.html" target="_top">hier.</a>
      <hr>
    </NOFRAMES>
EOM

$query->param("mode","query");
print "<frame src=".$query->self_url.">";
$query->param("mode","hit");
print "<frame src=".$query->self_url.">";

print <<EOM;
  </frameset>
</html>
EOM
print $query->end_html;
}

sub checkpw {
  my ($user,$passw)=@_;
  return undef unless ($user && $passw);
  my ($u,$p)=getpwnam($user);
  print "<b>$u $p $user $passw</b>";
  return ($u eq $user && $passw eq crypt($p,$passw));
}
